/*

  globals.c - global variables used by grinder

*/

#include <stdio.h>
#include "wnconsts.h"
#include "consts.h"
#include "typedef.h"

static char *Id = "$Id: globals.c,v 1.13 1996/05/30 20:56:48 wn Exp $";

char **Argv;
int Argc;
int nowarn = 0;			/* flag for suppressing warning messages */
FILE *logfile = stderr;		/* file to output error messages to */
Synset headss = NULL;		/* head of synset list */
struct {
    char *fname;		/* name of file */
    int present;		/* indicates whether file was specified
				   on command line */
} filelist[256];
int errcount=0;

Symbol hashtab[HASHSIZE];	/* hash table for words */

/* symbols used for pointer characters */ 

char *ptrsymbols[] = { 
    "(bad pointer type)",
    "!",			/* 1 ANTPTR (all) */
    "@",			/* 2 HYPERPTR (noun, verb) */
    "~",			/* 3 HYPOPTR (noun, verb) */
    "*",			/* 4 ENTAILPTR (verb) */
    "&",			/* 5 SIMPTR (adjective) */
    "#m",			/* 6 ISMEMBERPTR (noun) */
    "#s",			/* 7 ISSTUFFPTR (noun) */
    "#p",			/* 8 ISPARTPTR (noun) */
    "%m",			/* 9 HASMEMBERPTR (noun) */
    "%s",			/* 10 HASSTUFFPTR (noun) */
    "%p",			/* 11 HASPARTPTR (noun) */
    "#",			/* 12 MERONYM (noun) */
    "%",			/* 13 HOLONYM (noun) */
    ">",			/* 14 CAUSETO (verb) */
    "<",			/* 15 PPLPTR (adj) */
    "^",			/* 16 SEEALSOPTR (adjective, verb) */
    "\\",			/* 17 PERTAINSTO (adjective, noun, adverb) */
    "=",			/* 18 ATTRIBUTE (adjective, noun) */
    "$",			/* 19 VERBGROUP (verb) */
    NULL 
    };

char legalnounptrs[]= { 0,P_NOUN,P_NOUN,P_NOUN,0,0,P_NOUN,P_NOUN,P_NOUN,P_NOUN,
			P_NOUN,P_NOUN,P_NOUN,P_NOUN,0,0,0,P_ADJ,P_ADJ,0,0 };
char legalverbptrs[]= { 0,P_VERB,P_VERB,P_VERB,P_VERB,0,0,0,0,0,0,0,0,0,
			P_VERB,P_VERB,P_VERB,0,0,P_VERB,0 };
char legaladjptrs[]=  { 0,P_ADJ,0,0,0,P_ADJ,0,0,0,0,0,0,0,0,0,P_VERB,
			P_ADJ,P_NOUN | P_ADJ,P_NOUN,0,0 };
char legaladvptrs[] = { 0, P_ADV, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, P_ADJ, 0, 0, 0 };
char *legalptrsets[]={ NULL, legalnounptrs , legalverbptrs, legaladjptrs,
		       legaladvptrs };
char *legalptrs=NULL;

char *ptrreflects[] = {
    NULL,
    "!",
    "~",
    "@",
    NULL,
    "&",
    "%m",
    "%s",
    "%p",
    "#m",
    "#s",
    "#p",
    "%",
    "#",
    NULL,
    NULL,
    NULL,
    NULL,
    "=",
    "$",
    NULL,
    };


/* keep track of what parts of speech we've seen */

char partseen[] = { (char)0, (char)0, (char)0, (char)0, (char)0 };

/*
  Revision log:

  $Log: globals.c,v $
 * Revision 1.13  1996/05/30  20:56:48  wn
 * *** empty log message ***
 *
 * Revision 1.12  1994/09/27  19:51:30  wn
 * changed CAUSEDBY to PPLPTR
 *
 * Revision 1.11  1993/08/03  12:39:01  wn
 * *** empty log message ***
 *
 * Revision 1.10  93/04/21  12:40:17  wn
 * added new ATTRIBUTE pointer (=)
 * 
 * Revision 1.9  92/08/19  16:01:01  wn
 * added adv stuff
 * 
 * Revision 1.8  92/08/12  11:57:47  wn
 * *** empty log message ***
 * 
 * Revision 1.7  92/03/26  13:42:18  wn
 * removed unused pointers
 * 
 * Revision 1.6  92/01/21  13:37:01  wn
 * changed values in legal{noun,verb,adj}ptrs to use P_{NOUN,VERB,ADJ}
 * then changed P_NOUN to P_NOUN | P_ADJ for pertainyms in legaladjptrs
 * 
 * Revision 1.5  91/12/13  17:09:29  wn
 * changed include for wn.h to wnconsts.h
 * 
 * Revision 1.4  91/12/13  15:56:58  wn
 * removed variables that are now in wnglobals
 * 
 * Revision 1.3  91/11/26  15:05:26  wn
 * added pertainym pointer
 * 
 * Revision 1.2  91/09/27  11:45:26  wn
 * removed automatic reflection of see also (^)
 * 
 * Revision 1.1  91/09/11  14:49:09  wn
 * Initial revision
 * 
*/
